#define crypt_init
//XOR cryption 2.0
//by IsmAvatar
//Written in C, source code included in crypt.c

//The magical thing about XOR cryption is that it can encrypt or decrypt
 //using the same algorithm, as long as you use the same seed
//Thus, you can mix and match functions,
 //just as long as the seed matches up in the long run.
//A seed string and seed file containing the same characters
 //will work just fine. After all, calling cryptf or cryptof will just
 //read the seed file into a seed buffer string and then call crypt or crypto!
//A seed works best when very close to the From file
 //because then the To file becomes a bunch of zeroes
 //Of course, that's not always possible, so a very random seed works well
//Warning: the seed will be read completely into memory. All else is buffered 
//All functions return whether they were successful (true) or not (false)
//A failure usually only happens if E.G. the files could not be opened
 
global.fcryptdll = "crypt.dll"
global.fcrypt = external_define(global.fcryptdll,"crypt",dll_cdecl,0,4,1,1,1,0)
global.fcryptf = external_define(global.fcryptdll,"cryptf",dll_cdecl,0,3,1,1,1)
global.fcrypto = external_define(global.fcryptdll,"crypto",dll_cdecl,0,3,1,1,0)
global.fcryptof = external_define(global.fcryptdll,"cryptof",dll_cdecl,0,2,1,1)
#define crypt
//crypt(From,To,SeedStr)
//From - the input file containing the data you want crypted
//To - the output file that will contain the crypted data
//SeedStr - a seed string used to encrypt the data (like a password)
return external_call(global.fcrypt,argument0,argument1,argument2,string_length(argument2))
#define cryptf
//cryptf(From,To,SeedFile)
//From - the input file containing the data you want encrypted
//To - the output file that will contain the encrypted data
//SeedFile - a seed file used to encrypt the data (in place of a password)
return external_call(global.fcryptf,argument0,argument1,argument2)
#define crypto
//crypto(File,SeedStr)
//File - the file you want encrypted
//SeedStr - a seed string used to encrypt the data (like a password)
return external_call(global.fcrypto,argument0,argument1,string_length(argument1))
#define cryptof
//cryptof(File,SeedFile)
//File - the file you want encrypted
//SeedFile - a seed file used to encrypt the data (in place of a password)
return external_call(global.fcryptof,argument0,argument1)
#define crypt_end
external_free(global.fcryptdll)
